Index: /branches/OaaS/HeuristicLab.Services.Hive.WebRole/WebRole.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Hive.WebRole/WebRole.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Hive.WebRole/WebRole.cs	(revision 9215)
@@ -24,4 +24,5 @@
 using Microsoft.WindowsAzure.Diagnostics;
 using Microsoft.WindowsAzure.ServiceRuntime;
+using System.Diagnostics;
 
 namespace HeuristicLab.Services.Hive.WebRole {
@@ -31,18 +32,38 @@
 
     public override bool OnStart() {
+      Trace.WriteLine("Starting Janitor Service...");
+      try {
+        DiagnosticMonitorConfiguration diagnosticConfig = DiagnosticMonitor.GetDefaultInitialConfiguration();
+        /*diagnosticConfig.Directories.ScheduledTransferPeriod = TimeSpan.FromMinutes(1);
+        diagnosticConfig.Directories.DataSources.Add(AzureLocalStorageTraceListener.GetLogDirectory());*/
+        diagnosticConfig.Logs.ScheduledTransferPeriod = TimeSpan.FromMinutes(1);
+        diagnosticConfig.Logs.ScheduledTransferLogLevelFilter = LogLevel.Verbose;
+        diagnosticConfig.WindowsEventLog.ScheduledTransferPeriod = TimeSpan.FromMinutes(1);
+        diagnosticConfig.WindowsEventLog.ScheduledTransferLogLevelFilter = LogLevel.Verbose;
+        DiagnosticMonitor.Start("Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString", diagnosticConfig);
+      }
+      catch (Exception e) {
+        Trace.WriteLine("Error during diagnostic configuration: " + e.Message);
+      }
+
       // To enable the AzureLocalStorageTraceListner, uncomment relevent section in the web.config  
-      DiagnosticMonitorConfiguration diagnosticConfig = DiagnosticMonitor.GetDefaultInitialConfiguration();
-      diagnosticConfig.Directories.ScheduledTransferPeriod = TimeSpan.FromMinutes(1);
-      diagnosticConfig.Directories.DataSources.Add(AzureLocalStorageTraceListener.GetLogDirectory());
-
+      
+      Trace.WriteLine("Loading diagnostic configuration...");
+      
       // For information on handling configuration changes
       // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.
 
       // Start Janitorn Service:
-      janitor = new HiveJanitor();
-      janitorThread = new Thread(janitor.Run);
-      janitorThread.IsBackground = true; //dont keep app alive
-      janitorThread.Start();
-
+      Trace.WriteLine("Starting HiveJanitor...");
+      try {
+        janitor = new HiveJanitor();
+        janitorThread = new Thread(janitor.Run);
+        janitorThread.IsBackground = true; //dont keep app alive
+        janitorThread.Start();
+      }
+      catch (Exception e) {
+        Trace.WriteLine("Error during janitor startup: " + e.Message);
+      }
+      Trace.WriteLine("Startup completed...");
       return base.OnStart();
     }
@@ -51,5 +72,4 @@
       janitor.StopJanitor();
       janitorThread.Join();
-
       base.OnStop();
     }
Index: /branches/OaaS/HeuristicLab.Services.Hive/3.3/HiveDao.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Hive/3.3/HiveDao.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Hive/3.3/HiveDao.cs	(revision 9215)
@@ -28,4 +28,5 @@
 using HeuristicLab.Services.Hive.Interfaces;
 using System.Data.Common;
+using System.Configuration;
 
 namespace HeuristicLab.Services.Hive.DataAccess {
@@ -34,5 +35,11 @@
     public HiveDataContext CreateContext(bool longRunning = false) {
       //var context = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
-      var context = new HiveDataContext(provider.GetOpenConnection(Settings.Default.HiveConnectionStringName));      
+      HiveDataContext context;
+      if (ConfigurationManager.ConnectionStrings[Settings.Default.HiveConnectionStringName] == null) {
+        context = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
+      }
+      else {
+        context = new HiveDataContext(provider.GetOpenConnection(Settings.Default.HiveConnectionStringName));
+      }
       if (longRunning) context.CommandTimeout = (int)Settings.Default.LongRunningDatabaseCommandTimeout.TotalSeconds;
       return context;
Index: /branches/OaaS/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs	(revision 9215)
@@ -23,4 +23,5 @@
 using System.Threading;
 using HeuristicLab.Services.Hive.DataAccess;
+using System.Diagnostics;
 
 namespace HeuristicLab.Services.Hive {
@@ -55,4 +56,5 @@
         try {
           LogFactory.GetLogger(typeof(HiveJanitor).Namespace).Log("HiveJanitor: starting cleanup");
+          Trace.WriteLine("HiveJanitor: starting cleanup");
           bool cleanup = false;
           DateTime lastCleanup = DateTime.MinValue;
@@ -70,7 +72,9 @@
           }
           LogFactory.GetLogger(typeof(HiveJanitor).Namespace).Log("HiveJanitor: cleanup finished");
+          Trace.WriteLine("HiveJanitor: cleanup finished");
         }
         catch (Exception e) {
           LogFactory.GetLogger(typeof(HiveJanitor).Namespace).Log(string.Format("HiveJanitor: The following exception occured: {0}", e.ToString()));
+          Trace.WriteLine(string.Format("HiveJanitor: The following exception occured: {0}", e.ToString()));
         }
         waitHandle.WaitOne(HeuristicLab.Services.Hive.Properties.Settings.Default.CleanupInterval);
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Azure/DAL.cs	(revision 9215)
@@ -8,4 +8,5 @@
 using Microsoft.WindowsAzure.ServiceRuntime;
 using System.Diagnostics;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
 
 namespace HeuristicLab.Services.Optimization.ControllerService.Azure {
@@ -13,4 +14,5 @@
     public static readonly string SCENARIO_TABLE = "Scenario";
     public static readonly string SCENARIO_BLOB_CONTAINER = "scenario";
+    public static readonly string EXPERIMENT_TABLE = "Experiment";
     public static readonly string CLOUD_SETTINGS_KEY = "Cloudia.WindowsAzure.Storage";
   }
@@ -91,7 +93,96 @@
   }
 
+  internal sealed class ExperimentEntity : TableServiceEntity {
+    public ExperimentEntity() {
+    }
+
+    public ExperimentEntity(string user, Experiment experiment) {
+      PartitionKey = "ScenarioPartition";
+      RowKey = user + "_" + experiment.Name;
+      var scenarios = "";
+      foreach (var scen in experiment.Scenarios) {
+        scenarios += scen.Id + ",";
+      }
+      Scenarios = scenarios.Remove(scenarios.Length - 1);
+      User = user;
+    }
+
+    public string User { get; set; }
+
+    public string Scenarios { get; set; }
+
+  }
+
+  public class ExperimentDao : IExperimentDao {
+    public CloudBlobClient BlobClient { get; set; }
+    public CloudTableClient TableClient { get; set; }
+
+    public bool Add(string username, Model.Experiment experiment) {
+      if (FindByName(username, experiment.Name) != null)
+        return false;
+
+      TableServiceContext serviceContext = TableClient.GetDataServiceContext();
+      TableClient.CreateTableIfNotExist(AzureConstants.EXPERIMENT_TABLE);
+      var entity = new ExperimentEntity(username, experiment);
+      serviceContext.AddObject(AzureConstants.EXPERIMENT_TABLE, entity);
+      serviceContext.SaveChangesWithRetries();
+      return true;
+    }
+
+    public bool DeleteByName(string username, string experiment) {
+      TableServiceContext serviceContext = TableClient.GetDataServiceContext();
+      TableClient.CreateTableIfNotExist(AzureConstants.EXPERIMENT_TABLE);
+      var entity = (from e in serviceContext.CreateQuery<ExperimentEntity>(AzureConstants.EXPERIMENT_TABLE)
+                    where e.RowKey == (username + "_" + experiment)
+                    select e).FirstOrDefault();
+      
+      if (entity == null)
+        return false;
+
+      serviceContext.DeleteObject(entity);
+      serviceContext.SaveChangesWithRetries();
+      return true;
+    }
+
+    public Model.Experiment FindByName(string username, string experiment) {
+      TableServiceContext serviceContext = TableClient.GetDataServiceContext();
+      TableClient.CreateTableIfNotExist(AzureConstants.EXPERIMENT_TABLE);
+      var entity = (from e in serviceContext.CreateQuery<ExperimentEntity>(AzureConstants.EXPERIMENT_TABLE)
+                    where e.RowKey == (username + "_" + experiment)
+                    select e).FirstOrDefault();
+      
+      if (entity == null) {
+        return null;
+      }
+
+      var exp = Convert(entity);
+      return exp;
+    }
+
+    private Experiment Convert(ExperimentEntity entity) {
+      var exp = new Experiment() { Name = entity.RowKey.Split('_')[1] };
+      foreach (var scenarioName in entity.Scenarios.Split(','))
+        exp.Scenarios.Add(new OptimizationScenario() { Id = scenarioName });
+      return exp;
+    }
+
+    public IEnumerable<Model.Experiment> GetExperiments(string user) {
+      TableServiceContext serviceContext = TableClient.GetDataServiceContext();
+      TableClient.CreateTableIfNotExist(AzureConstants.EXPERIMENT_TABLE);
+      var entites = (from e in serviceContext.CreateQuery<ExperimentEntity>(AzureConstants.EXPERIMENT_TABLE)
+                    where e.User == user
+                    select e).ToList();
+      var experiments = new List<Experiment>();
+      foreach (var entity in entites) {
+        experiments.Add(Convert(entity));
+      }
+      return experiments;
+    }
+  }
+
   public class AzureDataAccessLayer : IDataAccessLayer {
     private IScenarioDao scenarioDao;
     private IBlobDao blobDao;
+    private IExperimentDao expDao;
 
     private CloudStorageAccount storageAccount;
@@ -115,5 +206,5 @@
       get {
         if (scenarioDao == null) {
-          scenarioDao = new ScenarioDao();
+          scenarioDao = new ScenarioDao() { TableClient = StorageAccount.CreateCloudTableClient() };
         }
         return scenarioDao;
@@ -124,5 +215,5 @@
       get {
         if (blobDao == null) {
-          blobDao = new BlobDao();
+          blobDao = new BlobDao() { BlobClient = StorageAccount.CreateCloudBlobClient() };
         }
         return blobDao;
@@ -130,10 +221,11 @@
     }
 
-    public IScenarioDao CreateScenarioDao() {
-      return new ScenarioDao() { TableClient = StorageAccount.CreateCloudTableClient() };
-    }
-
-    public IBlobDao CreateBlobDao() {
-      return new BlobDao() { BlobClient = StorageAccount.CreateCloudBlobClient() };
+    public IExperimentDao ExperimentDao {
+      get {
+        if (expDao == null) {
+          expDao = new ExperimentDao() { TableClient = StorageAccount.CreateCloudTableClient() };
+        }
+        return expDao;
+      }
     }
   }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HL/HiveScenarioManager.cs	(revision 9215)
@@ -52,5 +52,5 @@
     }
 
-    public void DispatchScenario(Model.User user, Model.OptimizationScenario scenario, JobExecutionDetails details) {
+    public string DispatchScenario(Model.User user, Model.OptimizationScenario scenario, JobExecutionDetails details) {
       // Experiment experiment = new Experiment();
       // var problem = new TravelingSalesmanProblem();
@@ -66,8 +66,8 @@
         br.Optimizer = algo;        
         br.Repetitions = details.Repititions;
-        SendExperimentToHive(user, br, details);
+        return SendExperimentToHive(user, br, details);
       }
       else {       
-        SendExperimentToHive(user, algo, details);
+        return SendExperimentToHive(user, algo, details);
       }
     }
@@ -141,5 +141,5 @@
     }
 
-    private void SendExperimentToHive(Model.User user, IOptimizer exp, JobExecutionDetails details) {      
+    private string SendExperimentToHive(Model.User user, IOptimizer exp, JobExecutionDetails details) {      
       var job = new RefreshableJob();
       job.IsAllowedPrivileged = true;      
@@ -156,6 +156,7 @@
         Console.WriteLine(ex.StackTrace); 
       }, job, new CancellationToken());
-
+      
       job.StopResultPolling();
+      return job.Id != null ? job.Id.ToString() : null;
     }
 
@@ -168,5 +169,5 @@
       foreach (var job in jobsLoaded) {
         jobs.Add(ConvertJob(user, job));
-      }
+      }      
       return jobs;
     }
@@ -182,4 +183,5 @@
       else
         state = JobState.Waiting;
+
       return new Model.Job() { Id = job.Id.ToString(), Name = job.Name, Resource = job.ResourceNames, State = state.Value, DateCreated = job.DateCreated };
     }
@@ -193,8 +195,9 @@
 
 
-    public void DeleteJob(User user, string id) {
+    public bool DeleteJob(User user, string id) {
       ConfigureHive(user);
-      var guid = Guid.Parse(id);
-      HiveServiceLocator.Instance.CallHiveService(s => s.DeleteJob(guid));      
+      var guid = Guid.Parse(id);      
+      HiveServiceLocator.Instance.CallHiveService(s => s.DeleteJob(guid));
+      return true;
     }
 
@@ -344,6 +347,6 @@
       
       // insert into table & blob store
-      var scenDao = dal.CreateScenarioDao();
-      var blobDao = dal.CreateBlobDao();
+      var scenDao = dal.ScenarioDao;
+      var blobDao = dal.BlobDao;
       
       Guid scenarioXmlGuid = Guid.NewGuid();
@@ -369,6 +372,6 @@
 
     private string GetMapperFromBlobStore(string scenarioName) {
-      var scenarioDao = dal.CreateScenarioDao();
-      var blobDao = dal.CreateBlobDao();
+      var scenarioDao = dal.ScenarioDao;
+      var blobDao = dal.BlobDao;
       var entity = scenarioDao.FindByName(scenarioName);
       if (entity == null)
@@ -383,6 +386,6 @@
     public bool DeleteScenario(User user, string scenarioName) {
       // delete from table & blob store
-      var scenarioDao = dal.CreateScenarioDao();
-      var blobDao = dal.CreateBlobDao();
+      var scenarioDao = dal.ScenarioDao;
+      var blobDao = dal.BlobDao;
 
       var entity = scenarioDao.FindByName(scenarioName);
@@ -395,4 +398,89 @@
       return true;
     }
+
+    public bool SaveExperiment(User user, Model.Experiment experiment) {
+      return dal.ExperimentDao.Add(user.Username, experiment);
+    }
+
+    public IEnumerable<string> GetExperiments(User user) {
+      return (from exp in dal.ExperimentDao.GetExperiments(user.Username)
+              select exp.Name);
+    }
+
+
+    public bool DeleteExperiment(User user, string experiment) {
+      return dal.ExperimentDao.DeleteByName(user.Username, experiment);
+    }
+
+
+    public Model.Task GetTaskData(User u, string jobId, string taskId) {
+      ConfigureHive(u);
+      TaskDownloader downloader = new TaskDownloader(new List<Guid>(){Guid.Parse(taskId)});
+      downloader.StartAsync();
+      while (!downloader.IsFinished) {
+        Thread.Sleep(250);
+        if (downloader.IsFaulted) {
+          throw downloader.Exception;
+        }
+      }
+      
+      IDictionary<Guid, HiveTask> hiveTasks = downloader.Results;
+      var task = hiveTasks[Guid.Parse(taskId)];
+      if (task == null) 
+        return null;
+      
+      return new Model.Task() {
+        State = new Model.TaskState() {
+          DateCreated = task.Task.DateCreated.ToString(),
+          DateFinished = task.Task.DateFinished.ToString(),
+          ExecutionTime = task.Task.ExecutionTime.ToString(),
+          State = task.Task.State.ToString()
+        },
+        General = new Model.General() {
+          Id = task.Task.Id.ToString(),
+          LastChanged = task.Task.Modified.ToString(),
+          Name = task.ItemTask.Name
+        }
+      };
+    }
+
+    public Model.Job GetTasks(User u, string jobId) {
+      ConfigureHive(u);
+      var jobTasks = HiveServiceLocator.Instance.CallHiveService<IEnumerable<HeuristicLab.Clients.Hive.LightweightTask>>(s => s.GetLightweightJobTasks(Guid.Parse(jobId)));
+      
+      var job = new Model.Job();
+      job.Id = jobId;
+      var tasks = new Dictionary<Guid, Model.Task>();
+      // push all elements to dictionary
+      foreach (var task in jobTasks) {
+        // TODO: Crawl children + parent and create hierarchy!
+        var children = HiveServiceLocator.Instance.CallHiveService<IEnumerable<HeuristicLab.Clients.Hive.LightweightTask>>(s => s.GetLightweightChildTasks(Guid.Parse(jobId), true, true));
+        foreach (var child in children) {
+          tasks[child.Id] = new Model.Task() {
+            State = new Model.TaskState() {
+              DateCreated = child.DateCreated.ToString(),
+              DateFinished = child.DateFinished.ToString(),
+              ExecutionTime = child.ExecutionTime.ToString(),
+              State = child.State.ToString()
+            },
+            General = new Model.General() {
+              Id = child.Id.ToString(),
+              LastChanged = child.Modified.ToString(),
+              Name = child.ItemName
+            }
+          };
+        }
+      }
+
+      // traverse all tasks again and create tree of tasks
+      foreach (var task in jobTasks) {
+        if (task.ParentTaskId.HasValue)
+          tasks[task.Id].Children.Add(tasks[task.ParentTaskId.Value]);
+        else // its a root task
+          job.Tasks.Add(tasks[task.Id]);
+      }
+
+      return job;
+    }
   }
 }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/HeuristicLab.Services.Optimization.ControllerService.csproj	(revision 9215)
@@ -151,4 +151,7 @@
     <Reference Include="Microsoft.WindowsAzure.ServiceRuntime, Version=1.7.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL" />
     <Reference Include="Microsoft.WindowsAzure.StorageClient, Version=1.7.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL" />
+    <Reference Include="Newtonsoft.Json">
+      <HintPath>..\packages\Newtonsoft.Json.4.5.11\lib\net40\Newtonsoft.Json.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.configuration" />
@@ -175,7 +178,8 @@
     <Compile Include="Mockup\MockupDAL.cs" />
     <Compile Include="Mockup\MockupScenarioManager.cs" />
+    <Compile Include="Parsers\AlgorithmConverter.cs" />
     <Compile Include="PlaceholderControllerService.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="HL\ScenarioParser.cs" />
+    <Compile Include="Parsers\ScenarioParser.cs" />
     <Compile Include="Utility.cs" />
   </ItemGroup>
@@ -186,5 +190,4 @@
     <None Include="packages.config" />
   </ItemGroup>
-  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/DAL.cs	(revision 9215)
@@ -3,4 +3,5 @@
 using System.Linq;
 using System.Text;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
 
 namespace HeuristicLab.Services.Optimization.ControllerService.Interfaces {
@@ -17,4 +18,11 @@
   }
 
+  public interface IExperimentDao {
+    bool Add(string username, Experiment experiment);
+    bool DeleteByName(string username, string experiment);
+    Experiment FindByName(string username, string experiment);
+    IEnumerable<Experiment> GetExperiments(string user);
+  }
+
   public interface IBlobDao {
     bool Add(StringEntry entry);
@@ -24,6 +32,7 @@
 
   public interface IDataAccessLayer {
-    IScenarioDao CreateScenarioDao();
-    IBlobDao CreateBlobDao();
+    IScenarioDao ScenarioDao { get; }
+    IBlobDao BlobDao { get; }
+    IExperimentDao ExperimentDao { get; }    
   }
 
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IControllerService.cs	(revision 9215)
@@ -20,5 +20,5 @@
 
     [OperationContract]
-    void ScheduleOptimizationScenario(User user, OptimizationScenario scenario, JobExecutionDetails details);
+    bool ScheduleOptimizationScenario(User user, OptimizationScenario scenario, JobExecutionDetails details);
 
     [OperationContract]
@@ -29,5 +29,5 @@
 
     [OperationContract]
-    void DeleteJob(User user, string id);
+    bool DeleteJob(User user, string id);
 
     [OperationContract]
@@ -39,4 +39,19 @@
     [OperationContract]
     bool DeleteHiveScenario(User user, string scenarioName);
+
+    [OperationContract]
+    bool SaveExperiment(User user, Experiment experiment);
+
+    [OperationContract]
+    IEnumerable<string> GetExperiments(User user);
+
+    [OperationContract]
+    bool DeleteExperiment(User user, string experiment);
+
+    [OperationContract]
+    Job GetTasks(User u, string jobId);
+
+    [OperationContract]
+    Task GetTaskData(User u, string jobId, string taskId);
   }
 }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/IScenarioManager.cs	(revision 9215)
@@ -7,11 +7,18 @@
 namespace HeuristicLab.Services.Optimization.ControllerService.Interfaces {
   public interface IScenarioManager {
-    void DispatchScenario(User user, OptimizationScenario scenario, JobExecutionDetails details);
+    string DispatchScenario(User user, OptimizationScenario scenario, JobExecutionDetails details);
     IList<Job> GetJobs(User user);
     Job GetJob(User user, string id);
-    void DeleteJob(User user, string id);
+    bool DeleteJob(User user, string id);
     IList<Model.Run> GetJobResults(User user, string id);
     bool AddScenario(User user, string scenarioName, string scenarioXml, string scenarioMapper);
     bool DeleteScenario(User user, string scenarioName);
+
+    bool SaveExperiment(User user, Experiment experiment);
+    IEnumerable<string> GetExperiments(User user);
+    bool DeleteExperiment(User user, string experiment);
+
+    Task GetTaskData(User u, string jobId, string taskId);
+    Job GetTasks(User u, string jobId);
   }
 }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/Model/ControllerModel.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/Model/ControllerModel.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Interfaces/Model/ControllerModel.cs	(revision 9215)
@@ -306,4 +306,7 @@
   public class Experiment {
     [DataMember]
+    public string Name { get; set; }
+
+    [DataMember]
     public IList<OptimizationScenario> Scenarios { get; set; }
 
@@ -340,4 +343,88 @@
 
   [DataContract]
+  public class Property {
+    [DataMember]
+    public string Key { get; set; }
+    [DataMember]
+    public string Value { get; set; }
+  }
+  
+  [DataContract]
+  public class General {
+    [DataMember]
+    public string Name { get { return GetValue("Name"); } set { SetValue("Name", value); } }
+    [DataMember]
+    public string Id { get { return GetValue("Id"); } set { SetValue("Id", value); } }
+    [DataMember]
+    public string Priority { get { return GetValue("Priority"); } set { SetValue("Priority", value); } }
+    [DataMember]
+    public string LastChanged { get { return GetValue("LastChanged"); } set { SetValue("LastChanged", value); } }
+
+    
+    private IList<Property> properties = new List<Property>();
+    [DataMember]
+	  public IList<Property> Properties
+	  {
+		  get { 
+        if (properties == null) 
+          properties = new List<Property>();
+        return properties;
+      }
+		  set { properties = value;}
+	  }
+
+    private string GetValue(string key) {      
+      return (from p in Properties where p.Key == key select p.Value).FirstOrDefault();
+    }
+
+    private void SetValue(string key, string value) {
+      var prop = (from p in Properties where p.Key == key select p).FirstOrDefault();
+      if (prop == null) {
+        prop = new Property();
+        Properties.Add(prop);
+      }
+      prop.Key = key;
+      prop.Value = value;
+    }
+  }
+
+  [DataContract]
+  public class TaskState {
+    [DataMember]
+    public string State { get; set; }
+    [DataMember]
+    public string ExecutionTime { get; set; }
+    [DataMember]
+    public string DateCreated { get; set; }
+    [DataMember]
+    public string DateFinished { get; set; }
+  }
+
+  [DataContract]
+  public class Task {
+    private General general = new General();
+    [DataMember]
+    public General General {
+      get { return general; }
+      set { general = value; }
+    }
+
+    private IList<Task> tasks = new List<Task>();
+    [DataMember]
+    public IList<Task> Children {
+      get { return tasks; }
+      set { tasks = value; }
+    }
+    
+    private TaskState state = new TaskState();
+
+    [DataMember]
+    public TaskState State {
+      get { return state; }
+      set { state = value; }
+    }
+  }
+
+  [DataContract]
   public class Job {
     [DataMember]
@@ -355,4 +442,13 @@
     [DataMember]
     public DateTime DateCreated { get; set; }
+
+    private IList<Task> tasks = new List<Task>();
+
+    [DataMember]
+    public IList<Task> Tasks {
+      get { return tasks; }
+      set { tasks = value; }
+    }
+
   }
 
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupDAL.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupDAL.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupDAL.cs	(revision 9215)
@@ -246,11 +246,12 @@
     }
 
-    public IScenarioDao CreateScenarioDao() {
-      return new ScenarioDao();
-    }
-
-    public IBlobDao CreateBlobDao() {
-      return new BlobDao();
-    }
+    private IExperimentDao experimentDao;
+
+    public IExperimentDao ExperimentDao {
+      get {         
+        return null; 
+      }      
+    }
+
   }
 }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Controller/Mockup/MockupScenarioManager.cs	(revision 9215)
@@ -131,6 +131,7 @@
     }
 
-    public void DispatchScenario(Model.User user, Model.OptimizationScenario scenario, JobExecutionDetails details) {
-      // does nothign
+    public string DispatchScenario(Model.User user, Model.OptimizationScenario scenario, JobExecutionDetails details) {
+      // does nothing
+      return "guid";
     }
 
@@ -144,6 +145,7 @@
 
 
-    public void DeleteJob(User user, string id) {
+    public bool DeleteJob(User user, string id) {
       jobs.RemoveAll(j => j.Id == id);
+      return true;
     }
 
@@ -199,6 +201,6 @@
       
       // insert into table & blob store
-      var scenDao = dal.CreateScenarioDao();
-      var blobDao = dal.CreateBlobDao();
+      var scenDao = dal.ScenarioDao;
+      var blobDao = dal.BlobDao;
       
       Guid scenarioXmlGuid = Guid.NewGuid();
@@ -225,6 +227,6 @@
     public bool DeleteScenario(User user, string scenarioName) {
       // delete from table & blob store
-      var scenarioDao = dal.CreateScenarioDao();
-      var blobDao = dal.CreateBlobDao();
+      var scenarioDao = dal.ScenarioDao;
+      var blobDao = dal.BlobDao;
 
       var entity = scenarioDao.FindByName(scenarioName);
@@ -237,4 +239,28 @@
       return true;
     }
+
+
+    public bool SaveExperiment(User user, Model.Experiment experiment) {
+      throw new NotImplementedException();
+    }
+
+
+    public IEnumerable<string> GetExperiments(User user) {
+      throw new NotImplementedException();
+    }
+
+
+    public bool DeleteExperiment(User user, string experiment) {
+      throw new NotImplementedException();
+    }
+
+
+    public Model.Task GetTaskData(User u, string jobId, string taskId) {
+      throw new NotImplementedException();
+    }
+
+    public Model.Job GetTasks(User u, string jobId) {
+      throw new NotImplementedException();
+    }
   }
 }
